/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareR2BucketEventNotificationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Account ID.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.5.0/docs/data-sources/r2_bucket_event_notification#account_id DataCloudflareR2BucketEventNotification#account_id}
    */
    readonly accountId: string;
    /**
    * Name of the bucket.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.5.0/docs/data-sources/r2_bucket_event_notification#bucket_name DataCloudflareR2BucketEventNotification#bucket_name}
    */
    readonly bucketName: string;
    /**
    * Queue ID.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.5.0/docs/data-sources/r2_bucket_event_notification#queue_id DataCloudflareR2BucketEventNotification#queue_id}
    */
    readonly queueId: string;
}
export interface DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionCondition {
}
export declare function dataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionConditionToTerraform(struct?: DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionCondition): any;
export declare function dataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionConditionToHclTerraform(struct?: DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionCondition): any;
export declare class DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionCondition | undefined;
    set internalValue(value: DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionCondition | undefined);
    get maxAge(): number;
    get type(): string;
}
export interface DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransition {
}
export declare function dataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionToTerraform(struct?: DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransition): any;
export declare function dataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionToHclTerraform(struct?: DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransition): any;
export declare class DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransition | undefined;
    set internalValue(value: DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransition | undefined);
    private _condition;
    get condition(): DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionConditionOutputReference;
}
export interface DataCloudflareR2BucketEventNotificationConditions {
}
export declare function dataCloudflareR2BucketEventNotificationConditionsToTerraform(struct?: DataCloudflareR2BucketEventNotificationConditions): any;
export declare function dataCloudflareR2BucketEventNotificationConditionsToHclTerraform(struct?: DataCloudflareR2BucketEventNotificationConditions): any;
export declare class DataCloudflareR2BucketEventNotificationConditionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareR2BucketEventNotificationConditions | undefined;
    set internalValue(value: DataCloudflareR2BucketEventNotificationConditions | undefined);
    get prefix(): string;
}
export interface DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionCondition {
}
export declare function dataCloudflareR2BucketEventNotificationDeleteObjectsTransitionConditionToTerraform(struct?: DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionCondition): any;
export declare function dataCloudflareR2BucketEventNotificationDeleteObjectsTransitionConditionToHclTerraform(struct?: DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionCondition): any;
export declare class DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionCondition | undefined;
    set internalValue(value: DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionCondition | undefined);
    get date(): string;
    get maxAge(): number;
    get type(): string;
}
export interface DataCloudflareR2BucketEventNotificationDeleteObjectsTransition {
}
export declare function dataCloudflareR2BucketEventNotificationDeleteObjectsTransitionToTerraform(struct?: DataCloudflareR2BucketEventNotificationDeleteObjectsTransition): any;
export declare function dataCloudflareR2BucketEventNotificationDeleteObjectsTransitionToHclTerraform(struct?: DataCloudflareR2BucketEventNotificationDeleteObjectsTransition): any;
export declare class DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareR2BucketEventNotificationDeleteObjectsTransition | undefined;
    set internalValue(value: DataCloudflareR2BucketEventNotificationDeleteObjectsTransition | undefined);
    private _condition;
    get condition(): DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionConditionOutputReference;
}
export interface DataCloudflareR2BucketEventNotificationStorageClassTransitionsCondition {
}
export declare function dataCloudflareR2BucketEventNotificationStorageClassTransitionsConditionToTerraform(struct?: DataCloudflareR2BucketEventNotificationStorageClassTransitionsCondition): any;
export declare function dataCloudflareR2BucketEventNotificationStorageClassTransitionsConditionToHclTerraform(struct?: DataCloudflareR2BucketEventNotificationStorageClassTransitionsCondition): any;
export declare class DataCloudflareR2BucketEventNotificationStorageClassTransitionsConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareR2BucketEventNotificationStorageClassTransitionsCondition | undefined;
    set internalValue(value: DataCloudflareR2BucketEventNotificationStorageClassTransitionsCondition | undefined);
    get date(): string;
    get maxAge(): number;
    get type(): string;
}
export interface DataCloudflareR2BucketEventNotificationStorageClassTransitions {
}
export declare function dataCloudflareR2BucketEventNotificationStorageClassTransitionsToTerraform(struct?: DataCloudflareR2BucketEventNotificationStorageClassTransitions): any;
export declare function dataCloudflareR2BucketEventNotificationStorageClassTransitionsToHclTerraform(struct?: DataCloudflareR2BucketEventNotificationStorageClassTransitions): any;
export declare class DataCloudflareR2BucketEventNotificationStorageClassTransitionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareR2BucketEventNotificationStorageClassTransitions | undefined;
    set internalValue(value: DataCloudflareR2BucketEventNotificationStorageClassTransitions | undefined);
    private _condition;
    get condition(): DataCloudflareR2BucketEventNotificationStorageClassTransitionsConditionOutputReference;
    get storageClass(): string;
}
export declare class DataCloudflareR2BucketEventNotificationStorageClassTransitionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareR2BucketEventNotificationStorageClassTransitionsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.5.0/docs/data-sources/r2_bucket_event_notification cloudflare_r2_bucket_event_notification}
*/
export declare class DataCloudflareR2BucketEventNotification extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_r2_bucket_event_notification";
    /**
    * Generates CDKTF code for importing a DataCloudflareR2BucketEventNotification resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareR2BucketEventNotification to import
    * @param importFromId The id of the existing DataCloudflareR2BucketEventNotification that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.5.0/docs/data-sources/r2_bucket_event_notification#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareR2BucketEventNotification to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.5.0/docs/data-sources/r2_bucket_event_notification cloudflare_r2_bucket_event_notification} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareR2BucketEventNotificationConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareR2BucketEventNotificationConfig);
    private _abortMultipartUploadsTransition;
    get abortMultipartUploadsTransition(): DataCloudflareR2BucketEventNotificationAbortMultipartUploadsTransitionOutputReference;
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _bucketName?;
    get bucketName(): string;
    set bucketName(value: string);
    get bucketNameInput(): string | undefined;
    private _conditions;
    get conditions(): DataCloudflareR2BucketEventNotificationConditionsOutputReference;
    private _deleteObjectsTransition;
    get deleteObjectsTransition(): DataCloudflareR2BucketEventNotificationDeleteObjectsTransitionOutputReference;
    get enabled(): cdktf.IResolvable;
    get id(): string;
    private _queueId?;
    get queueId(): string;
    set queueId(value: string);
    get queueIdInput(): string | undefined;
    private _storageClassTransitions;
    get storageClassTransitions(): DataCloudflareR2BucketEventNotificationStorageClassTransitionsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
